namespace ReportLibrary1
{
    using System;
    using Telerik.Reporting;

    /// <summary>
    /// Summary description for Report1
    /// </summary>
    public partial class Report1 : Telerik.Reporting.Report
    {

        public Report1()
        {
            //
            // Required for telerik Reporting designer support
            //
            InitializeComponent();

            DataSource csvDataSource = this.GetFirstDataSource();
            //DataSource csvDataSource = this.GetSecondDataSource();
            this.FormatBandReportBasedOnDataSource(csvDataSource);
        }

        private void FormatBandReportBasedOnDataSource(DataSource dataSource)
        {
            //Applicable for CsvDataSource
            CsvDataSource csvDataSource = (CsvDataSource)dataSource;
            this.DataSource = csvDataSource;
            var width = Telerik.Reporting.Drawing.Unit.Inch(1.1770833730697632D);
            var height = Telerik.Reporting.Drawing.Unit.Inch(0.2395833283662796D);
            var zeroInch = Telerik.Reporting.Drawing.Unit.Inch(0D);

            for (int i = 0; i < csvDataSource.Columns.Count; i++)
            {
                DataColumn dataColumn = csvDataSource.Columns[i];
                Telerik.Reporting.TextBox textBoxHeader = new Telerik.Reporting.TextBox();
                Telerik.Reporting.TextBox textBoxDetail = new Telerik.Reporting.TextBox();

                // 
                // textBoxHeader
                // 
                textBoxHeader.Name = $"textBoxHeader{2 * i}";
                textBoxHeader.Size = new Telerik.Reporting.Drawing.SizeU(width, height);
                textBoxHeader.Style.BackgroundColor = System.Drawing.Color.Lime;
                textBoxHeader.Style.BorderStyle.Default = Telerik.Reporting.Drawing.BorderType.Solid;
                textBoxHeader.Value = dataColumn.Name;
                textBoxHeader.Location = new Telerik.Reporting.Drawing.PointU(width*i, zeroInch);
                // 
                // textBoxDetail
                // 
                textBoxDetail.Name = $"textBoxDetail{2 * i}";
                textBoxDetail.Size = new Telerik.Reporting.Drawing.SizeU(width, height);
                textBoxDetail.Style.BorderStyle.Default = Telerik.Reporting.Drawing.BorderType.Solid;
                textBoxDetail.Value = $"= Fields.{dataColumn.Name}";
                textBoxDetail.Location = new Telerik.Reporting.Drawing.PointU(width * i, zeroInch);

                this.groupHeaderSection.Items.Add(textBoxHeader);
                this.detail.Items.Add(textBoxDetail);
            }
        }

        private DataSource GetFirstDataSource()
        {
            // 
            // csvDataSource1
            //
            Telerik.Reporting.CsvDataSource csvDataSource1 = new Telerik.Reporting.CsvDataSource();
            Telerik.Reporting.DataColumn dataColumn1 = new Telerik.Reporting.DataColumn();
            Telerik.Reporting.DataColumn dataColumn2 = new Telerik.Reporting.DataColumn();
            Telerik.Reporting.DataColumn dataColumn3 = new Telerik.Reporting.DataColumn();
            dataColumn1.Name = "CompanyName";
            dataColumn2.Name = "EmployeeName";
            dataColumn3.Name = "Age";
            dataColumn3.Type = Telerik.Reporting.SimpleType.Integer;
            csvDataSource1.Columns.Add(dataColumn1);
            csvDataSource1.Columns.Add(dataColumn2);
            csvDataSource1.Columns.Add(dataColumn3);
            csvDataSource1.FieldSeparators = new char[] {
        ','};
            csvDataSource1.HasHeaders = true;
            csvDataSource1.Name = "csvDataSource1";
            csvDataSource1.RecordSeparators = new char[] {
        '\r',
        '\n'};
            csvDataSource1.Source = "CompanyName,EmployeeName,Age\r\nGoogle,James,39\r\nGoogle,Jane,23\r\nApple,Catherine,30" +
    "\r\nSamsung,Bob,23\r\nSamsung,Jully,32\r\nSamsung,Nicolas,43";

            return csvDataSource1;
        }

        private DataSource GetSecondDataSource()
        {
            // 
            // csvDataSource2
            //
            Telerik.Reporting.CsvDataSource csvDataSource2 = new Telerik.Reporting.CsvDataSource();
            Telerik.Reporting.DataColumn dataColumn1 = new Telerik.Reporting.DataColumn();
            Telerik.Reporting.DataColumn dataColumn2 = new Telerik.Reporting.DataColumn();
            Telerik.Reporting.DataColumn dataColumn3 = new Telerik.Reporting.DataColumn();
            Telerik.Reporting.DataColumn dataColumn4 = new Telerik.Reporting.DataColumn();
            dataColumn1.Name = "CompanyName";
            dataColumn2.Name = "CompanyId";
            dataColumn2.Type = Telerik.Reporting.SimpleType.Integer;
            dataColumn3.Name = "SomeData";
            dataColumn4.Name = "OtherData";
            csvDataSource2.Columns.Add(dataColumn1);
            csvDataSource2.Columns.Add(dataColumn2);
            csvDataSource2.Columns.Add(dataColumn3);
            csvDataSource2.Columns.Add(dataColumn4);
            csvDataSource2.FieldSeparators = new char[] {
        ','};
            csvDataSource2.HasHeaders = true;
            csvDataSource2.Name = "csvDataSource2";
            csvDataSource2.RecordSeparators = new char[] {
        '\r',
        '\n'};
            csvDataSource2.Source = "CompanyName,CompanyId,SomeData,OtherData\r\nGoogle,1,googleData,otherGOOGLE\r\nApple," +
    "2,appleData,otherAPPLE\r\nSamsung,3,samsungData,otherSAMSUNG";

            return csvDataSource2;
        }
    }
}